## zmap 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (ZMAP C)

option(WITH_REDIS "Build with support for Redis DB" OFF)
option(WITH_JSON "Build with support for JSON" OFF)
option(ENABLE_DEVELOPMENT "Enable development specific compiler and linker flags" OFF)
option(ENABLE_HARDENING "Add hardening specific compiler and linker flags" ON)

if(ENABLE_DEVELOPMENT)
	# Hardening and warnings for building with gcc
	# Maybe add -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations
	set(GCCWARNINGS 
		"-Wall -Wformat=2 -Wno-format-nonliteral"
		"-pedantic -fno-strict-aliasing"
		"-Wextra"
		"-Wfloat-equal -Wundef -Wwrite-strings -Wredundant-decls"
		"-Wnested-externs -Wbad-function-cast -Winit-self"
		"-Wmissing-noreturn -Wnormalized=id"
		"-Wstack-protector"
		"-Werror"
		)

	# Fix line breaks
	string(REPLACE ";" " "  GCCWARNINGS "${GCCWARNINGS}")

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCCWARNINGS} -g")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -g")
endif()

if(ENABLE_HARDENING)
	set(GCCHARDENING "-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -fstack-protector-all -fwrapv -fPIC --param ssp-buffer-size=1")
	set(LDHARDENING "-z relro -z now")

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCCHARDENING}")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LDHARDENING}")
endif()

if(WITH_REDIS)
	set(REDIS_LIBS hiredis)
	add_definitions("-DREDIS")
endif()

if(WITH_JSON)
	include(FindPkgConfig)
	pkg_check_modules(JSON json)
	if(JSON_FOUND)
		include_directories(JSON_INCLUDE_DIRS)
	else()
		message(FATAL_ERROR "Did not find libjson")
	endif()

	add_definitions("-DJSON")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${JSON_CFLAGS}")
endif()

# Standard FLAGS
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")

# Extra target FLAGS
set(CMAKE_C_FLAGS_DEBUG "-O2 -g")
set(CMAKE_C_FLAGS_RELEASE "-O2")

add_subdirectory(src)

# Install conf files
FILE(GLOB CONF_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/conf" "conf/*")
message(STATUS "${CONF_FILES}")
configure_file(zmap_conf_install.cmake.in zmap_conf_install.cmake)
install(SCRIPT zmap_conf_install.cmake)

=== src/CMakeLists.txt ===
include_directories(
	"${CMAKE_CURRENT_BINARY_DIR}"
	${PROJECT_SOURCE_DIR}/lib
	${PROJECT_SOURCE_DIR}/src
	${PROJECT_SOURCE_DIR}/src/output_modules
	)

SET(LIB_SOURCES
	${PROJECT_SOURCE_DIR}/lib/blacklist.c
	${PROJECT_SOURCE_DIR}/lib/constraint.c
	${PROJECT_SOURCE_DIR}/lib/logger.c
	${PROJECT_SOURCE_DIR}/lib/pbm.c
	${PROJECT_SOURCE_DIR}/lib/random.c
	${PROJECT_SOURCE_DIR}/lib/rijndael-alg-fst.c
	${PROJECT_SOURCE_DIR}/lib/stack.c
	${PROJECT_SOURCE_DIR}/lib/xalloc.c
)

# ADD YOUR PROBE MODULE HERE
SET(EXTRA_PROBE_MODULES

	)

# ADD YOUR OUTPUT MODULE HERE
SET(EXTRA_OUTPUT_MODULES
	)

SET(OUTPUT_MODULE_SOURCES
	output_modules/module_csv.c
	output_modules/output_modules.c
	)

SET(PROBE_MODULE_SOURCES
	probe_modules/module_icmp_echo.c
	probe_modules/module_tcp_synscan.c
	probe_modules/module_udp.c
	probe_modules/packet.c
	probe_modules/probe_modules.c
	)

SET(SOURCES
	aesrand.c
	cyclic.c
	expression.c
	fieldset.c
	filter.c
	get_gateway.c
	monitor.c
	recv.c
	send.c
	state.c
	validate.c
	zmap.c
	zopt_compat.c
	"${CMAKE_CURRENT_BINARY_DIR}/zopt.h"
	"${CMAKE_CURRENT_BINARY_DIR}/lexer.c"
	"${CMAKE_CURRENT_BINARY_DIR}/parser.c"
	${EXTRA_PROBE_MODULES}
	${EXTRA_OUTPUT_MODULES}
	${PROBE_MODULE_SOURCES}
	${OUTPUT_MODULE_SOURCES}
	${LIB_SOURCES}
	)

if (WITH_JSON)
	SET(SOURCES ${SOURCES} output_modules/module_json.c)
endif()

if (WITH_REDIS)
	SET(SOURCES ${SOURCES} ${PROJECT_SOURCE_DIR}/lib/redis.c output_modules/module_redis.c output_modules/module_csvredis.c)
endif()

add_custom_command(OUTPUT zopt.h
	COMMAND gengetopt -C --no-help --no-version --unamed-opts=SUBNETS -i "${CMAKE_CURRENT_SOURCE_DIR}/zopt.ggo" -F "${CMAKE_CURRENT_BINARY_DIR}/zopt"
	)

add_custom_command(OUTPUT lexer.c
	COMMAND flex -o "${CMAKE_CURRENT_BINARY_DIR}/lexer.c" --header-file="${CMAKE_CURRENT_BINARY_DIR}/lexer.h" lexer.l
	)

add_custom_command(OUTPUT parser.c
	COMMAND byacc -d -o parser.c parser.y
	)

add_executable(zmap ${SOURCES})

target_link_libraries(
	zmap 
	pcap gmp m
	${REDIS_LIBS}
	${JSON_LIBRARIES}
	)

# Install binary
install(
	TARGETS
	zmap
	RUNTIME DESTINATION sbin
)

# Install Manpages
install(
	FILES
	zmap.1
	DESTINATION share/man/man1
	)

=== examples/banner-grab/Makefile ===


CFLAGS+=-I../../lib/ -Wall
LDFLAGS+=-lpcap -levent -levent_extra -lm
VPATH=../../lib/

# from dpkg-buildflags --get CFLAGS, but use stack-protector-all and fPIC
GCCHARDENING=-g -O2 -fstack-protector-all --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -fPIC
# from gpkg-buildflags --get LDFLAGS, + -z,now
LDHARDENING=-Wl,-Bsymbolic-functions -Wl,-z,relro,-z,now

CFLAGS+=$(GCCHARDENING)
LDFLAGS+=$(LDHARDENING)


all: banner-grab-tcp

banner-grab-tcp: banner-grab-tcp.o logger.o
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

clean:
	rm -f banner-grab-tcp *.o

=== examples/forge-socket/Makefile ===


CFLAGS+=-I../../lib/ -I../../forge_socket -Wall
LDFLAGS+=-lpcap -levent -levent_extra -lm
VPATH=../../lib/

# from dpkg-buildflags --get CFLAGS, but use stack-protector-all and fPIC
GCCHARDENING=-g -O2 -fstack-protector-all --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -fPIC
# from gpkg-buildflags --get LDFLAGS, + -z,now
LDHARDENING=-Wl,-Bsymbolic-functions -Wl,-z,relro,-z,now

CFLAGS+=$(GCCHARDENING)
LDFLAGS+=$(LDHARDENING)


all: forge-socket

forge-socket: forge-socket.o logger.o
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

clean:
	rm -f forge-socket *.o

=== debian/changelog ===
zmap (1.1.0-1) unstable; urgency=low

  * Initial release.

 -- Clint Adams <clint@debian.org>  Tue, 10 Dec 2013 21:40:04 -0500

=== debian/control ===
Source: zmap
Section: net
Priority: optional
Maintainer: Clint Adams <clint@debian.org>
Build-Depends: debhelper (>= 9), cmake, libgmp-dev, libpcap-dev, gengetopt, byacc, flex, libjson-c-dev, pkg-config
Standards-Version: 3.9.5
Homepage: https://zmap.io/
Vcs-Git: git://git.debian.org/collab-maint/zmap.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/zmap.git;a=summary

Package: zmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: network scanner for researchers
 ZMap is a network scanner that enables researchers to
 easily perform Internet-wide network studies. With a single
 machine and a well provisioned network uplink, ZMap is capable of
 performing a complete scan of the IPv4 address space in under 45
 minutes, approaching the theoretical limit of gigabit Ethernet.
 .
 ZMap can be used to study protocol adoption over time, monitor
 service availability, and help us better understand large systems
 distributed across the Internet.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_HARDENING=ON # -DWITH_JSON=ON

## zmap 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (ZMAP C)
SET (VERSION 1.2.0)

option(WITH_REDIS "Build with support for Redis DB" OFF)
option(WITH_JSON "Build with support for JSON" OFF)
option(ENABLE_DEVELOPMENT "Enable development specific compiler and linker flags" OFF)
option(RESPECT_INSTALL_PREFIX_CONFIG "Respect CMAKE_INSTALL_PREFIX for /etc" OFF)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
	set(USING_CLANG "YES")
else()
	set(USING_GCC "YES")
endif()

if ("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD" OR "${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
   set(BSD "YES")
endif()

# Hardening and warnings for building with gcc
# Maybe add -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations
set(GCCWARNINGS 
	"-Wall -Wformat=2 -Wno-format-nonliteral"
	"-pedantic -fno-strict-aliasing"
	"-Wextra"
	"-Wfloat-equal -Wundef -Wwrite-strings -Wredundant-decls"
	"-Wnested-externs -Wbad-function-cast -Winit-self"
	"-Wmissing-noreturn"
	"-Wstack-protector"
	)

# Fix line breaks
string(REPLACE ";" " "  GCCWARNINGS "${GCCWARNINGS}")

if(ENABLE_DEVELOPMENT)
	set(GCCWARNINGS "${GCCWARNINGS} -Werror")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -g")
else()
	# Hardening and optimizations for building with gcc
	set(GCCHARDENING "-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -fstack-protector-all -fwrapv -fPIC --param ssp-buffer-size=1")
	if (NOT APPLE AND NOT BSD)
		set(LDHARDENING "-z relro -z now")
	else()
		set(LDHARDENING "")
	endif()

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCCHARDENING} -O2")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LDHARDENING}")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCCWARNINGS}")

if(WITH_REDIS)
	set(REDIS_LIBS hiredis)
	add_definitions("-DREDIS")
endif()

if(WITH_JSON)
	include(FindPkgConfig)
	pkg_check_modules(JSON json-c)
	if(NOT JSON_FOUND)
		# Support for versions of json-c with the old pkgconfig name
		message(STATUS "Could not find json-c, checking for json instead")
		pkg_check_modules(JSON json)
	endif()
	if(JSON_FOUND)
		include_directories(JSON_INCLUDE_DIRS)
	else()
		message(FATAL_ERROR "Did not find libjson")
	endif()

	add_definitions("-DJSON")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${JSON_CFLAGS}")
endif()



# Standard FLAGS
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
if (NOT APPLE)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
endif()

add_subdirectory(src)

# Install conf files

FILE(GLOB CONF_FILES "${PROJECT_SOURCE_DIR}/conf/*")
if (RESPECT_INSTALL_PREFIX_CONFIG)
	set(CONFIG_DESTINATION "etc/zmap")
else()
	set(CONFIG_DESTINATION "/etc/zmap")
endif()

install(
	FILES
	${CONF_FILES}
	DESTINATION ${CONFIG_DESTINATION}
)

# Allow Debian Packaging
INCLUDE (InstallRequiredSystemLibraries)

SET (CPACK_SET_DESTDIR "on")
SET (CPACK_PACKAGING_INSTALL_PREFIX "/tmp")
SET (CPACK_GENERATOR "DEB")

SET (${VERSION} CPACK_DEBIAN_PACKAGE_VERSION)
SET (CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
SET (CPACK_DEBIAN_PACKAGE_SECTION "network")
SET (CPACK_DEBIAN_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
SET (CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.1.3), libgmp10, libpcap0.8")

SET (CPACK_PACKAGE_DESCRIPTION "Internet-scale network scanner")
SET (CPACK_PACKAGE_DESCRIPTION_SUMMARY "ZMap is an open-source network scanner that enables researchers to easily perform Internet-wide network studies. With a single machine and a well provisioned network uplink, ZMap is capable of performing a complete scan of the IPv4 address space in under 45 minutes, approaching the theoretical limit of gigabit Ethernet. ZMap can be used to study protocol adoption over time, monitor service availability, and help us better understand large systems distributed across the Internet.")
SET (CPACK_PACKAGE_CONTACT "Zakir Durumeric <zakird@gmail.com>")
SET (CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${VERSION}_${CPACK_DEBIAN_ARCHITECTURE}")

SET (CPACK_COMPONENTS_ALL Libraries ApplicationData)

INCLUDE(CPack)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,20 @@
 	${PROJECT_SOURCE_DIR}/src
 	${PROJECT_SOURCE_DIR}/src/output_modules
 	)
+
+if (APPLE)
+	if (EXISTS /opt/local/include)
+		include_directories(/opt/local/include)
+	endif()
+	if (EXISTS /opt/local/lib)
+		link_directories(/opt/local/lib)
+	endif()
+endif()
+
+if (BSD)
+	include_directories(/usr/local/include)
+	link_directories(/usr/local/lib)
+endif()
 
 SET(LIB_SOURCES
 	${PROJECT_SOURCE_DIR}/lib/blacklist.c
@@ -12,7 +26,6 @@
 	${PROJECT_SOURCE_DIR}/lib/pbm.c
 	${PROJECT_SOURCE_DIR}/lib/random.c
 	${PROJECT_SOURCE_DIR}/lib/rijndael-alg-fst.c
-	${PROJECT_SOURCE_DIR}/lib/stack.c
 	${PROJECT_SOURCE_DIR}/lib/xalloc.c
 )
 
@@ -45,9 +58,11 @@
 	fieldset.c
 	filter.c
 	get_gateway.c
+	iterator.c
 	monitor.c
 	recv.c
 	send.c
+	shard.c
 	state.c
 	validate.c
 	zmap.c
@@ -72,21 +87,31 @@
 
 add_custom_command(OUTPUT zopt.h
 	COMMAND gengetopt -C --no-help --no-version --unamed-opts=SUBNETS -i "${CMAKE_CURRENT_SOURCE_DIR}/zopt.ggo" -F "${CMAKE_CURRENT_BINARY_DIR}/zopt"
+	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/zopt.ggo"
 	)
 
 add_custom_command(OUTPUT lexer.c
-	COMMAND flex -o "${CMAKE_CURRENT_BINARY_DIR}/lexer.c" --header-file="${CMAKE_CURRENT_BINARY_DIR}/lexer.h" lexer.l
+	COMMAND flex -o "${CMAKE_CURRENT_BINARY_DIR}/lexer.c" --header-file="${CMAKE_CURRENT_BINARY_DIR}/lexer.h" "${CMAKE_CURRENT_SOURCE_DIR}/lexer.l"
+	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/lexer.l"
 	)
 
 add_custom_command(OUTPUT parser.c
-	COMMAND byacc -d -o parser.c parser.y
+	COMMAND byacc -d -o "${CMAKE_CURRENT_BINARY_DIR}/parser.c" "${CMAKE_CURRENT_SOURCE_DIR}/parser.y"
+	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/parser.y"
 	)
 
 add_executable(zmap ${SOURCES})
 
+if (APPLE OR BSD)
+	set(DNET_LIBRARIES "dnet")
+else()
+	set(DNET_LIBRARIES "")
+endif()
+
 target_link_libraries(
 	zmap 
 	pcap gmp m
+	${DNET_LIBRARIES}
 	${REDIS_LIBS}
 	${JSON_LIBRARIES}
 	)

=== debian/changelog ===
zmap (1.2.0-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.
  * No source changes required.

 -- Wessel Dankers <wsl@fruit.je>  Wed, 11 Jun 2014 10:27:37 +0200

zmap (1.2.0-1) unstable; urgency=medium

  * Imported Upstream version 1.2.0

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Mon, 10 Mar 2014 20:31:27 +0100

zmap (1.1.2-2) unstable; urgency=medium

  * Added json support
  * Added patch to fix spelling error in redis.c
  * Added redis support

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Thu, 06 Mar 2014 12:46:42 +0100

zmap (1.1.2-1) unstable; urgency=medium

  * New maintainer (Closes: #738468)
  * Added watch file
  * debian/copyright added new maintainer
  * debian/control
    - spelling fix
    - fixed Vcs fields to be canonical
  * debian/patches/02-fix-hyphenation-in-man
    - fixes hyphen-used-as-minus-sign in zmap.1
  * New upstream version 

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Tue, 18 Feb 2014 23:35:49 +0100

## zmap 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,12 @@
 cmake_minimum_required (VERSION 2.6)
 project (ZMAP C)
-SET (VERSION 1.2.0)
+SET (VERSION 1.2.1)
 
 option(WITH_REDIS "Build with support for Redis DB" OFF)
 option(WITH_JSON "Build with support for JSON" OFF)
 option(ENABLE_DEVELOPMENT "Enable development specific compiler and linker flags" OFF)
 option(RESPECT_INSTALL_PREFIX_CONFIG "Respect CMAKE_INSTALL_PREFIX for /etc" OFF)
+option(WITH_WERROR "Build with -Werror" OFF)
 
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
 	set(USING_CLANG "YES")
@@ -32,8 +33,11 @@
 # Fix line breaks
 string(REPLACE ";" " "  GCCWARNINGS "${GCCWARNINGS}")
 
+if(WITH_WERROR)
+	set(GCCWARNINGS "${GCCWARNINGS} -Werror")
+endif()
+
 if(ENABLE_DEVELOPMENT)
-	set(GCCWARNINGS "${GCCWARNINGS} -Werror")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb")
 	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -g")
 else()

=== debian/changelog ===
zmap (1.2.1-1) unstable; urgency=medium

  * Spelling patch added
  * Imported Upstream version 1.2.1

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Mon, 30 Jun 2014 13:22:28 +0200

=== debian/control ===
Source: zmap
Section: net
Priority: optional
Maintainer: Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>
Build-Depends:
 byacc,
 cmake,
 debhelper (>= 9),
 flex,
 gengetopt,
 libgmp-dev,
 libhiredis-dev,
 libjson-c-dev,
 libpcap-dev,
 pkg-config
Standards-Version: 3.9.5
Homepage: https://zmap.io/
Vcs-Git: git://anonscm.debian.org/collab-maint/zmap.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zmap.git;a=summary

Package: zmap
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: network scanner for researchers
 ZMap is a network scanner that enables researchers to
 easily perform Internet-wide network studies. With a single
 machine and a well provisioned network uplink, ZMap is capable of
 performing a complete scan of the IPv4 address space in under 45
 minutes, approaching the theoretical limit of gigabit Ethernet.
 .
 ZMap can be used to study protocol adoption over time, monitor
 service availability, and help people better understand large systems
 distributed across the Internet.

## zmap 2.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
project(ZMAP C)
set(ZMAP_VERSION 2.1.1)

option(WITH_REDIS "Build with support for Redis DB" OFF)
option(WITH_MONGO "Build with support for MongoDB" OFF)
option(WITH_JSON "Build with support for JSON" ON)
option(ENABLE_DEVELOPMENT "Enable development specific compiler and linker flags" OFF)
option(RESPECT_INSTALL_PREFIX_CONFIG "Respect CMAKE_INSTALL_PREFIX for /etc" OFF)
option(WITH_WERROR "Build with -Werror" OFF)
option(WITH_PFRING "Build with PF_RING ZC for send (10 GigE)" OFF)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(USING_CLANG "YES")
else()
    set(USING_GCC "YES")
endif()

if("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD" OR "${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
    set(BSD "YES")
endif()

# Hardening and warnings for building with gcc
# Maybe add -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations
set(GCCWARNINGS
    "-Wall -Wformat=2 -Wno-format-nonliteral"
    "-pedantic -fno-strict-aliasing"
    "-Wextra"
    "-Wfloat-equal -Wundef -Wwrite-strings -Wredundant-decls"
    "-Wnested-externs -Wbad-function-cast -Winit-self"
    "-Wmissing-noreturn"
    "-Wstack-protector"
)

# Fix line breaks
string(REPLACE ";" " "  GCCWARNINGS "${GCCWARNINGS}")

if(WITH_WERROR)
    set(GCCWARNINGS "${GCCWARNINGS} -Werror")
endif()

if(ENABLE_DEVELOPMENT)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -g")
else()
    # Hardening and optimizations for building with gcc
    set(GCCHARDENING "-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -fstack-protector-all -fwrapv -fPIC --param ssp-buffer-size=1")
    if(NOT APPLE AND NOT BSD)
        set(LDHARDENING "-z relro -z now")
    else()
        set(LDHARDENING "")
    endif()

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCCHARDENING} -O2")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LDHARDENING}")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GCCWARNINGS}")

if(WITH_REDIS)
    set(REDIS_LIBS hiredis)
    add_definitions("-DREDIS")
endif()

if(WITH_JSON)
    include(FindPkgConfig)
    pkg_check_modules(JSON json-c)
    if(JSON_FOUND)
        include_directories(${JSON_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Did not find libjson")
    endif()

    add_definitions("-DJSON")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${JSON_CFLAGS}")
endif()

if(WITH_MONGO)
    include(FindPkgConfig)
    pkg_check_modules(MONGO libmongoc-1.0)
    if(MONGO_FOUND)
        include_directories(${MONGO_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Did not find libmongoc-1.0")
    endif()
    add_definitions("-DMONGODB")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${MONGO_CFLAGS_OTHER}")
endif()

if(WITH_PFRING)
    add_definitions("-DPFRING")
    set(PFRING_LIBRARIES pfring rt numa)
endif()

# Standard FLAGS
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
if(NOT APPLE)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
endif()

# Set up OS-specific include directories
if(APPLE)
    if(EXISTS /opt/local/include)
        include_directories(/opt/local/include)
    endif()
    if(EXISTS /opt/local/lib)
        link_directories(/opt/local/lib)
    endif()
    if(EXISTS /usr/local/include)
        include_directories(/usr/local/include)
    endif()
    if(EXISTS /usr/local/lib)
        link_directories(/usr/local/lib)
    endif()
endif()

if(BSD)
    include_directories(/usr/local/include)
    link_directories(/usr/local/lib)
endif()

add_subdirectory(lib)
add_subdirectory(src)

# Install conf files
if(RESPECT_INSTALL_PREFIX_CONFIG)
    set(CONFIG_DESTINATION "etc/zmap")
else()
    set(CONFIG_DESTINATION "/etc/zmap")
endif()

FILE(GLOB CONF_FILES "${PROJECT_SOURCE_DIR}/conf/*")

message(STATUS "Default ZMap configuration file location is /etc/zmap")
foreach(EACH_CONF ${CONF_FILES})
    get_filename_component(CONF_BASENAME ${EACH_CONF} NAME)
    message(STATUS "Checking if ${CONF_BASENAME} exists there...")
    if(NOT EXISTS "/etc/zmap/${CONF_BASENAME}")
        install(FILES ${EACH_CONF} DESTINATION ${CONFIG_DESTINATION})
    else()
        message(WARNING "Existing configuration file detected at /etc/zmap/${CONF_BASENAME}, ${CONF_BASENAME} from sources will NOT be installed. Please check and install manually!")
    endif()
endforeach()

# Allow Debian Packaging
include(InstallRequiredSystemLibraries)

set(CPACK_SET_DESTDIR "on")
set(CPACK_PACKAGING_INSTALL_PREFIX "/tmp")
set(CPACK_GENERATOR "DEB")

set(${VERSION} CPACK_DEBIAN_PACKAGE_VERSION)
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_SECTION "network")
set(CPACK_DEBIAN_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.1.3), libgmp10, libpcap0.8")

set(CPACK_PACKAGE_DESCRIPTION "Internet-scale network scanner")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ZMap is an open-source network scanner that enables researchers to easily perform Internet-wide network studies. With a single machine and a well provisioned network uplink, ZMap is capable of performing a complete scan of the IPv4 address space in under five minutes, approaching the theoretical limit of gigabit Ethernet. ZMap can be used to study protocol adoption over time, monitor service availability, and help us better understand large systems distributed across the Internet.")
set(CPACK_PACKAGE_CONTACT "Zakir Durumeric <zakird@gmail.com>")
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${VERSION}_${CPACK_DEBIAN_ARCHITECTURE}")

set(CPACK_COMPONENTS_ALL Libraries ApplicationData)

include(CPack)

=== lib/CMakeLists.txt ===
SET(LIB_SOURCES
    blacklist.c
    constraint.c
    logger.c
    pbm.c
    random.c
    rijndael-alg-fst.c
    xalloc.c
    lockfd.c
    util.c
    queue.c
    csv.c
)

if (WITH_REDIS)
    SET(LIB_SOURCES ${LIB_SOURCES} redis.c)
endif()

add_library(zmaplib STATIC ${LIB_SOURCES})

target_include_directories (zmaplib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== src/CMakeLists.txt ===
include_directories(
    "${CMAKE_CURRENT_BINARY_DIR}"
    ${PROJECT_SOURCE_DIR}/lib
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/output_modules
)

# ADD YOUR PROBE MODULE HERE
set(EXTRA_PROBE_MODULES
)

# ADD YOUR OUTPUT MODULE HERE
set(EXTRA_OUTPUT_MODULES
)

set(OUTPUT_MODULE_SOURCES
    output_modules/module_csv.c
    output_modules/output_modules.c
)

# Handle optional output modules
if(WITH_JSON)
    set(OUTPUT_MODULE_SOURCES ${OUTPUT_MODULE_SOURCES} output_modules/module_json.c)
endif()

if(WITH_REDIS)
    set(OUTPUT_MODULE_SOURCES ${OUTPUT_MODULE_SOURCES} output_modules/module_redis_packed.c output_modules/module_redis_csv.c)
endif()

if(WITH_MONGO)
    set(OUTPUT_MODULE_SOURCES ${OUTPUT_MODULE_SOURCES} output_modules/module_mongodb.c)
endif()

set(PROBE_MODULE_SOURCES
    probe_modules/module_icmp_echo.c
    probe_modules/module_icmp_echo_time.c
    probe_modules/module_tcp_synscan.c
    probe_modules/module_udp.c
    probe_modules/packet.c
    probe_modules/probe_modules.c
    probe_modules/module_ntp.c
    probe_modules/module_upnp.c
)

set(SOURCES
    aesrand.c
    cyclic.c
    expression.c
    fieldset.c
    filter.c
    get_gateway.c
    iterator.c
    monitor.c
    recv.c
    send.c
    shard.c
    socket.c
    state.c
    summary.c
    validate.c
    zmap.c
    zopt_compat.c
    "${CMAKE_CURRENT_BINARY_DIR}/zopt.h"
    "${CMAKE_CURRENT_BINARY_DIR}/lexer.c"
    "${CMAKE_CURRENT_BINARY_DIR}/parser.c"
    ${EXTRA_PROBE_MODULES}
    ${EXTRA_OUTPUT_MODULES}
    ${PROBE_MODULE_SOURCES}
    ${OUTPUT_MODULE_SOURCES}
)

set(ZBLSOURCES
    zblacklist.c
    zbopt_compat.c
    "${CMAKE_CURRENT_BINARY_DIR}/zbopt.h"
)

set(ZTEESOURCES
    ztee.c
    topt_compat.c
    "${CMAKE_CURRENT_BINARY_DIR}/topt.h"
)

# Handle various versions of socket
if(WITH_PFRING)
    set(SOURCES ${SOURCES} socket-pfring.c)
elseif(APPLE OR BSD)
    set(SOURCES ${SOURCES} socket-bsd.c)
else()
    set(SOURCES ${SOURCES} socket-linux.c)
endif()

# Handle various versions of recv
if(WITH_PFRING)
    set(SOURCES ${SOURCES} recv-pfring.c)
else()
    set(SOURCES ${SOURCES} recv-pcap.c)
endif()

configure_file(topt.ggo.in ${CMAKE_BINARY_DIR}/src/topt.ggo @ONLY)
configure_file(zbopt.ggo.in ${CMAKE_BINARY_DIR}/src/zbopt.ggo @ONLY)
configure_file(zopt.ggo.in ${CMAKE_BINARY_DIR}/src/zopt.ggo @ONLY)

add_custom_command(OUTPUT zopt.h
    COMMAND gengetopt -C --no-help --no-version --unamed-opts=SUBNETS -i "${CMAKE_CURRENT_SOURCE_DIR}/zopt.ggo" -F "${CMAKE_CURRENT_BINARY_DIR}/zopt"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/zopt.ggo"
)

add_custom_command(OUTPUT topt.h
    COMMAND gengetopt -S --no-help --no-version --unamed-opts=FILE -i "${CMAKE_CURRENT_SOURCE_DIR}/topt.ggo" -F "${CMAKE_CURRENT_BINARY_DIR}/topt"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/topt.ggo"
)

add_custom_command(OUTPUT zbopt.h
    COMMAND gengetopt -C --no-help --no-version -i "${CMAKE_CURRENT_SOURCE_DIR}/zbopt.ggo" -F "${CMAKE_CURRENT_BINARY_DIR}/zbopt"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/zbopt.ggo"
)

add_custom_command(OUTPUT lexer.c
    COMMAND flex -o "${CMAKE_CURRENT_BINARY_DIR}/lexer.c" --header-file="${CMAKE_CURRENT_BINARY_DIR}/lexer.h" "${CMAKE_CURRENT_SOURCE_DIR}/lexer.l"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/lexer.l"
)

add_custom_command(OUTPUT parser.c
    COMMAND byacc -d -o "${CMAKE_CURRENT_BINARY_DIR}/parser.c" "${CMAKE_CURRENT_SOURCE_DIR}/parser.y"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/parser.y"
)

add_executable(zmap ${SOURCES})
add_executable(zblacklist ${ZBLSOURCES})
add_executable(ztee ${ZTEESOURCES})

if(APPLE OR BSD)
    set(DNET_LIBRARIES "dnet")
else()
    set(DNET_LIBRARIES "")
endif()

target_link_libraries(
    zmap
    zmaplib
    ${PFRING_LIBRARIES}
    pcap gmp m
    ${DNET_LIBRARIES}
    ${REDIS_LIBS}
    ${JSON_LIBRARIES}
    ${MONGO_LIBRARIES}
)

target_link_libraries(
    zblacklist
    zmaplib
    m
)

target_link_libraries(
    ztee
    zmaplib
    m
)

# Install binary
install(
    TARGETS
    zmap
    zblacklist
    ztee
    RUNTIME DESTINATION sbin
)

# Install Manpages
install(
    FILES
    zmap.1
    zblacklist.1
    ztee.1
    DESTINATION share/man/man1
)

=== examples/forge-socket/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 all: forge-socket
 
-forge-socket: forge-socket.o logger.o
+forge-socket: forge-socket.o xalloc.o logger.o
 	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)
 
 clean:

=== debian/changelog ===
zmap (2.1.1-2) unstable; urgency=medium

  * Refreshed 02fix_conffiles to install conffile (Closes: #802641)

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Thu, 29 Oct 2015 09:07:58 +0100

zmap (2.1.1-1) unstable; urgency=medium

  * Imported Upstream version 2.1.1
  * d/patches:
    - 01fix_ronn_files removed, fixed in upstream
    - 02fix_conffiles refreshed
    - fix_build_in_Debian added to fix cmake paths  
  * wrap-and-sorted 
  * added udp-probes to d/zmap.examples

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Fri, 02 Oct 2015 15:07:14 +0200

zmap (2.1.0-1) unstable; urgency=medium

  * Imported Upstream version 2.1.0
  * d/control: Bump standards to 3.9.6, no changes needed
  * d/patches/01fix_ronn_files.patch: Generating man pages with whatis
    header
  * d/patches/02fix_conffiles.patch: Fix for conffiles installing in etc

 -- Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>  Tue, 08 Sep 2015 16:16:13 +0200

=== debian/control ===
--- 
+++ 
@@ -2,25 +2,25 @@
 Section: net
 Priority: optional
 Maintainer: Dariusz Dwornikowski <dariusz.dwornikowski@cs.put.poznan.pl>
-Build-Depends:
- byacc,
- cmake,
- debhelper (>= 9),
- flex,
- gengetopt,
- libgmp-dev,
- libhiredis-dev,
- libjson-c-dev,
- libpcap-dev,
- pkg-config
-Standards-Version: 3.9.5
+Build-Depends: byacc,
+               cmake (>= 2.8.12),
+               debhelper (>= 9),
+               flex,
+               gengetopt,
+               libgmp-dev,
+               libhiredis-dev,
+               libjson-c-dev,
+               libpcap-dev,
+               pkg-config,
+Standards-Version: 3.9.6
 Homepage: https://zmap.io/
 Vcs-Git: git://anonscm.debian.org/collab-maint/zmap.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zmap.git;a=summary
 
 Package: zmap
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
 Description: network scanner for researchers
  ZMap is a network scanner that enables researchers to
  easily perform Internet-wide network studies. With a single

=== debian/watch ===
version=3
https://github.com/zmap/zmap/releases .*/archive/v(\d[\d\.]+)\.tar\.gz
